#include<iostream>

using namespace std;

// Bitte hier die Klasse tower definieren:

class tower
{
   int zahlen[100];
   int pos;

   public:
      tower ()
      {   pos = 0;
      }

      int shorten ()
      {
          if (pos == 0)
             return -1;
          
          pos--;
          int zahl = zahlen[pos];
          return zahl;
      }

      bool heighten (int zahl)
      {
          if (zahl < 0 || pos > 100)
             return false;

          zahlen[pos]= zahl;
          pos++; 
          return true;
      }

      int get_max()
      {
         int max = -1;
         int etage = -1;
         for (int i=0; i < pos; i++)
            if (zahlen[i] > max)
            {
               max = zahlen[i];
               etage = i;
            }

         if (etage != -1)
            return etage+1;
         else
            return -1;
      }
};


int main ()
{
   tower zahlenturm;
   int zahlen[5] = { 3, 8, 298, 34, 11 };

   // -----------------------------
   cout << "\n1. Test:\n";
   cout << "Turm hat 0 Etagen - Entfernen einer Zahl:\n";
   if (zahlenturm.shorten () == -1)
      cout << "Zahl konnte nicht entfernt werden <-- richtig\n";
   else
   {
      cout << "Fehler: Es wurde eine Zahl entfernt\n";
      return 0;
   }

   // -----------------------------
   cout << "\n2. Test:\n";
   cout << "Turm hat 0 Etagen - Etage mit groesster Zahl bestimmen:\n";
   if (zahlenturm.get_max() != -1)
   {    cout << "Fehler: get_max liefert " << zahlenturm.get_max()
            << "muesste aber -1 sein\n";
        return 0;
   } 
   else
       cout << "Noch keine Zahl im Turm gespeichert <-- richtig\n";


   // -----------------------------
   cout << "\n3. Test:\n";
   cout << "5 Zahlen einfuegen:\n";
   for (int i=0; i < 5; i++)
   {  if (! zahlenturm.heighten(zahlen[i]))
      {   cout << "Fehler: Zahl " << zahlen[i] << " kann nicht eingefuegt werden.\n";
          return 0;
      }
      else
          cout << zahlen[i] << " wurde eingefuegt\n";
   }

   // -----------------------------
   cout << "\n4. Test:\n";
   cout << "Etage mit groesster Zahl im Turm:\n";
   if (zahlenturm.get_max() != 3)
   {    cout << "Fehler: get_max liefert " << zahlenturm.get_max()
            << " muesste aber 3 sein\n";
        return 0;
   } 
   else
       cout << zahlenturm.get_max() << " <-- richtig\n";

   // -----------------------------
   cout << "\n5. Test:\n";
   cout << "Entfernen der letzten drei Zahlen:\n";
   for (int i= 1; i<= 3; i++)
   {
      int tzahl = zahlenturm.shorten ();
      if (tzahl != -1)
         cout << "Zahl " <<  tzahl << " wurde entfernt <-- richtig\n";
      else
      {
         cout << "Fehler: Zahl konnte nicht entfernt werden\n";
         return 0;
      }
   }

   // -----------------------------
   cout << "\n6. Test:\n";
   cout << "Etage mit groesster Zahl im Turm:\n";
   if (zahlenturm.get_max() != 2)
   {    cout << "Fehler: get_max liefert " << zahlenturm.get_max()
            << " muesste aber 2 sein\n";
        return 0;
   } 
   else
       cout << zahlenturm.get_max() << " <-- richtig\n";


   // -----------------------------
   cout << "\n7. Test:\n";
   cout << "-1 in den Turm einfuegen: \n";
   if (zahlenturm.heighten(-1))
      {   cout << "Fehler: -1 darf nicht eingefuegt werden.\n";
          return 0;
      }
      else
          cout << "-1 darf nicht eingefuegt werden <-- richtig\n";

  // -----------------------------
   cout << "\n8. Test:\n";
   cout << "1 in den Turm einfuegen: \n";
   if (! zahlenturm.heighten(1))
      {   cout << "Fehler: 1 konnte nicht eingefuegt werden.\n";
          return 0;
      }
      else
          cout << "1 wurde eingefuegt <-- richtig\n";

   // -----------------------------
   cout << "\n9. Test:\n";
   cout << "Etage mit groesster Zahl im Turm:\n";
   if (zahlenturm.get_max() != 2)
   {    cout << "Fehler: get_max liefert " << zahlenturm.get_max()
            << " muesste aber 2 sein\n";
        return 0;
   } 
   else
       cout << zahlenturm.get_max() << " <-- richtig\n";


   // Ok:
   cout << "\nHerzlichen Glueckwunsch. Alle Tests bestanden.\n";
   
// Ende von main:
   return 0;
}
